###################################################
### chunk number 1: 
###################################################
library("Biobase")
library("genefilter")
data(sample.ExpressionSet)
varLabels(sample.ExpressionSet)
table(sample.ExpressionSet$sex)
table(sample.ExpressionSet$type)


###################################################
### chunk number 2: 
###################################################
f1 <- kOverA(5, 200)
ffun <- filterfun(f1)
which <- genefilter(exprs(sample.ExpressionSet), ffun)
sum(which)


###################################################
### chunk number 3: 
###################################################
tf1 <- ttest(sample.ExpressionSet$type, .1)
ff2 <- filterfun(tf1)
wh2 <- genefilter(exprs(sample.ExpressionSet), ff2)
 sum(wh2)


###################################################
### chunk number 4: 
###################################################
ff3 <- filterfun(f1, tf1)
wh3 <- genefilter(exprs(sample.ExpressionSet), ff3)
sum(wh3)


###################################################
### chunk number 5: aggregate
###################################################

 knnCV <- function(EXPR, selectfun, cov, Agg, pselect = 0.01, Scale=FALSE) {
   nc <- ncol(EXPR)
   outvals <- rep(NA, nc)
   for(i in 1:nc) {
      v1 <- EXPR[,i]
      expr <- EXPR[,-i]
      glist <- selectfun(expr, cov[-i], p=pselect)
      expr <- expr[glist,]
      if( Scale ) {
        expr <- scale(expr)
        v1 <- as.vector(scale(v1[glist]))
      }
      else
         v1 <- v1[glist]
      out <- paste("iter ",i, " num genes= ", sum(glist), sep="")
      print(out)
      Aggregate(row.names(expr), Agg)
      if( length(v1) == 1)
         outvals[i] <- knn(expr, v1, cov[-i], k=5)
      else
          outvals[i] <- knn(t(expr), v1, cov[-i], k=5)
    }
    return(outvals)
  }


###################################################
### chunk number 6: aggregate
###################################################
 gfun <- function(expr, cov, p=0.05) {
    f2 <- ttest(cov, p=p)
    ffun <- filterfun(f2)
    which <- genefilter(expr, ffun)
  }



###################################################
### chunk number 7: aggregate
###################################################
  library("class")


  ##scale the genes
  ##genescale is a slightly more flexible "scale"
  ##work on a subset -- for speed only
  geneData <- genescale(exprs(sample.ExpressionSet)[1:75,], 1)

  Agg <- new("aggregator")

  testcase <- knnCV(geneData, gfun, sample.ExpressionSet$type, 
         Agg, pselect=0.05)

  genes.used <- as.list(aggenv(Agg))
  genes.counts <- as.numeric(genes.used)
  names(genes.counts) <- names(genes.used)
  sort(genes.counts)


###################################################
### chunk number 8: 
###################################################
toLatex(sessionInfo())


